<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_miniorange_azuresync
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Intc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */ 
/**
 * AccountSetup Controller
 *
 * @package     Joomla.Administrator
 * @subpackage  com_miniorange_azuresync
 * @since       0.0.9
 */
defined('_JEXEC') or die('Restricted access');
 JHtml::_('script', JUri::base() . 'components/com_miniorange_azuresync/assets/js/jquery.1.11.0.min.js');
 JHtml::_('script', JUri::base() . 'components/com_miniorange_azuresync/assets/js/utilityjs.js');
 JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_azuresync/assets/css/miniorange_boot.css');
 JHtml::_('stylesheet', JURI::base() .'components/com_miniorange_azuresync/assets/css/miniorange_license.css');


 class MiniorangeAzuresyncControllerAccountsetup extends JControllerForm
 {
	
function __construct()
	{
	$this->view_list = 'accountsetup';
	parent::__construct();
}
	 
//TO SAVE THE AZURE CONFIGURATION
function moAzureSyncSaveConfig() {
	$post=	JFactory::getApplication()->input->post->getArray();

	$mo_azure_application_id = isset($post['mo_azure_application_id'])?$post['mo_azure_application_id']:'';
	$mo_azure_client_secret = isset($post['mo_azure_client_secret'])? $post['mo_azure_client_secret'] : '';
	$mo_azure_tenant_id =isset($post['mo_azure_tenant_id'])? $post['mo_azure_tenant_id'] : "";
	$mo_azure_tenant_name = isset($post['mo_azure_tenant_name'])? $post['mo_azure_tenant_name'] : "";
	$mo_azure_test_upn  = isset($post['mo_azure_test_upn'])? $post['mo_azure_test_upn'] : "";

	if( empty($mo_azure_application_id)|| empty($mo_azure_client_secret) ){	
		$message =  JText::_('COM_MINIORANGE_ENTER_APPLICATION_ID');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=azureconfiguration',$message,'error');
		return;
	}		

	$database_name = '#__miniorange_azure_sync_config';
	$updatefieldsarray = array(
		'mo_azure_sync_application_id' 	  	=> trim($mo_azure_application_id),
		'mo_azure_sync_client_secret' 	  	=> trim($mo_azure_client_secret),
		'mo_azure_tenant_id' 	 	   		=> trim($mo_azure_tenant_id),	
		'mo_azure_tenant_name' 				=> trim($mo_azure_tenant_name),
		'mo_azure_sync_upn'					=> trim($mo_azure_test_upn),		
	);

	$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
	
	MoAzureCustomer::mo_azure_efficiency_check('NA');
	$message =  JText::_('COM_MINIORANGE_CONNECTION_SUCCESSFULLY_SAVED');
	$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=azureconfiguration',$message );
}


function moAzureGetClient(){

	$config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
 	$user_details = Azure::mo_azos_get_specific_user_detail();

	if($user_details =="ACCESS_TOKEN_MISSING"){
		$message = JText::_('COM_MINIORANGE_CHECK_APP_CREDENTIALS');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=azureconfiguration',$message,'error');	
		return;
	}
	$is_error = isset($user_details['error']) ? $user_details['error'] : '';
	
	if($is_error=='')
	$test_configuration = 'Success';
	else
	$test_configuration = 'Not Successful';

	MoAzureCustomer::mo_azure_efficiency_check($test_configuration);
	if($is_error){
		?>
		<div style="display:flex;justify-content:center;align-items:center;flex-direction:column;border:1px solid #eee;padding:10px;">
			<div style="width:90%;color:#fff;background-color: #ff6e6e;padding: 2%;margin-bottom: 20px;text-align: center;border: 1px solid #b71c1c;font-size: 18pt;">
				<?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL');?>
			</div>
			<p class="mo_boot_my-4"><?php echo JText::_('COM_MINIORANGE_TEST_UNSUCCESSFUL_DETAILS');?></p>
		</div>
		<?php exit;}
	else{
	
	?>
	<div style="display:flex;justify-content:center;align-items:center;flex-direction:column;border:1px solid #eee;padding:10px;">
		<div style="width:90%;color: #3c763d;background-color: #dff0d8;padding: 2%;margin-bottom: 20px;text-align: center;border: 1px solid #AEDB9A;font-size: 18pt;">
		<?php echo JText::_('COM_MINIORANGE_TEST_SUCCESSFUL');?>
		</div>

		<div class="test-container mo_boot_my-4" style="margin-top:10px;">
			<table class="mo-ms-tab-content-app-config-table">
				<tr >
					<td class="mo_boot_text-center" colspan="2">
						<span><h2 style="text-align:center;margin:2%"><?php echo JText::_('COM_MINIORANGE_TEST_ATTRIBUTES');?></h2></span>
					</td>
				</tr>
				<?php
				$azure_user_attributes = "";
				foreach ($user_details as $key => $value){
					if(gettype($value)=='object'){continue;}
					else{
						$azure_user_attributes .= $key.","; 
						
					?>
						
				<tr >
					<td style="bold;padding:2%;border:2px solid #949090; word-wrap:break-word;"><span><?php echo $key;?></span></td>
					<td style="padding:2%;border:2px solid #949090; word-wrap:break-word;"><span><?php echo $value;?></span></td>
				</tr>
				<?php
			
				}
			}
				?>
			</table>
		</div>
		</div>
<?php 	

		$database_name = '#__miniorange_azure_sync_config';
		$updatefieldsarray = array(
			'mo_azure_test_attributes' 	  	=> trim($azure_user_attributes),	
		);
		$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
		exit;
		}
}


//TO MANUALLY CREATE USER IN AZURE AD
public function moAzureCreateUserInAd()
{
	$post=	JFactory::getApplication()->input->post->getArray();
	$username = $post['mo_ad_sync_username'];

	if((strpos($username, '@') )){
		$username = strtok($username,  '@');
	}

	$status = Azure::mo_azure_create_user_in_ad($username);
	
	if($status =="ACCESS_TOKEN_MISSING"){
		$message = JText::_('COM_MINIORANGE_ACCESS_TOKEN_MISSING');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync',$message,'error');	
		return;
	}

	$is_error = isset($status->error) ? $status->error : '';
	if($is_error){
		$message = $status->error->message;
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message, 'error');
		return;
	}
	else{
		$message = JText::_('COM_MINIORANGE_JOOMLA_TO_AZURE_SYNC_CREATE_INDIVIDUAL_USER_SUCCESSFUL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message);
		return;
	}
	
}

//TO DELETE USER IN AD
public function moAzureDeleteUserInAd()
{
	$post=	JFactory::getApplication()->input->post->getArray();
	$username = $post['ad_sync_delete_username'];
	$config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
	$tenant_name = $config['mo_azure_tenant_name'];
	$check_string = '@'.$tenant_name;
	
	if (strpos($username, '@') ){
		if(!strpos($username, $check_string)){
			
			$message = JText::_('COM_MINIORANGE_JOOMLA_TO_AZURE_SYNC_DELETE_USER_INVALID_USERNAME');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message, 'error');
			return;
		}
	}
		
	$status = Azure::mo_azure_sync_delete_user_in_ad($username);

	if($status =="ACCESS_TOKEN_MISSING"){
		$message = JText::_('COM_MINIORANGE_ACCESS_TOKEN_MISSING');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync',$message,'error');	
		return;
	}
	
	$is_error = isset($status->error) ? $status->error : '';

	if($is_error){
		$message = $status->error->message;
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message, 'error');
		return;
	}
	else{
		$message = JText::_('COM_MINIORANGE_JOOMLA_TO_AZURE_SYNC_DELETE_USER_SUCCESSFUL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message);
		return;
    }
}


public function moAzureSyncAllUserInJoomla()
{
	$config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
	$mo_azure_application_id = $config['mo_azure_sync_application_id'];
	$mo_azure_client_secret = $config['mo_azure_sync_client_secret'];
	$mo_azure_username = $config['mo_azure_username'];
	$mo_azure_name = $config['mo_azure_name'];
	$mo_azure_email = $config['mo_azure_email'];
	
	if($mo_azure_application_id=='' || $mo_azure_client_secret==''){
		$message = JText::_('COM_MINIORANGE_FILL_CLIENT_ID_AND_SECRET');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=azureconfiguration', $message, 'error');
		return;
	}

	if($mo_azure_username=='' || $mo_azure_name=='' || $mo_azure_email == ''){
		$message = JText::_('COM_MINIORANGE_ENTER_NAME_USERNAME_EMAIL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message, 'error');
		return;
	}
	$status = Azure::mo_azure_sync_all_users_in_joomla($mo_azure_username, $mo_azure_name, $mo_azure_email);

	if($status == 'ACCESS_TOKEN_MISSING'){
		$message = JText::_('COM_MINIORANGE_ACCESS_TOKEN_MISSING');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message, 'error');
		return;
	}
	else if ($status == 'USERS_CREATED'){
		$message = JText::_('COM_MINIORANGE_AZURE_TO_JOOMLA_SYNC_ALL_USERS_SUCCESSFUL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message);
		return;
	}
	else{
		$message = JText::_('COM_MINIORANGE_AZURE_TO_JOOMLA_SYNC_ALL_USERS_UNSUCCESSFUL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message);
	}
}

public function moAzureSyncUserInJoomla(){
	$post =	JFactory::getApplication()->input->post->getArray();
	$mo_azure_username_sync = isset($post['mo_azure_user_to_sync'])? $post['mo_azure_user_to_sync']: '';

	$config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
	if(isset($config['mo_azure_sync_application_id'])){
	
		$mo_azure_application_id = $config['mo_azure_sync_application_id'];
		$mo_azure_client_secret = $config['mo_azure_sync_client_secret'];
		$mo_azure_username = $config['mo_azure_username'];
		$mo_azure_name = $config['mo_azure_name'];
		$mo_azure_email = $config['mo_azure_email'];
	}

	if($mo_azure_application_id=='' || $mo_azure_client_secret==''){
		$message = JText::_('COM_MINIORANGE_FILL_CLIENT_ID_AND_SECRET');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=azureconfiguration', $message, 'error');
		return;
	}

	if($mo_azure_username=='' || $mo_azure_name=='' || $mo_azure_email == ''){
		$message = JText::_('COM_MINIORANGE_ENTER_NAME_USERNAME_EMAIL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message, 'error');
		return;
	}

	$status = Azure::mo_azure_sync_individual_user_in_joomla($mo_azure_username_sync,$mo_azure_username, $mo_azure_name, $mo_azure_email);
	if($status =="ACCESS_TOKEN_MISSING"){
		$message = JText::_('COM_MINIORANGE_ACCESS_TOKEN_MISSING');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync',$message,'error');	
		return;
	}
	else if($status == 'USER_NOT_PRESENT'){
		$message = JText::_('COM_MINIORANGE_AZURE_TO_JOOMLA_SYNC_USER_UNSUCCESSFUL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync',$message,'error');	
		return;
	}
	else{
		$message = JText::_('COM_MINIORANGE_AZURE_TO_JOOMLA_SYNC_USER_SUCCESSFUL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync', $message);
	}
}

//SUPPORT FUNCTION
function moAzureContactUs()
{
	$post =	JFactory::getApplication()->input->post->getArray();
	$query_email = isset($post['mo_azure_query_email'])? $post['mo_azure_query_email'] : '';
	$query = isset($post['mo_azure_query']) ? $post['mo_azure_query'] : '';

	if (sizeof(array_unique(str_split($query))) < 10) {
		$message =  JText::_('COM_MINIORANGE_ENTER_PROPER_QUERY');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message, 'error');
		return;
	}

	if (MoAzureUtility::mo_azure_check_empty_or_null($query_email) || MoAzureUtility::mo_azure_check_empty_or_null($query)) {
		$message =  JText::_('COM_MINIORANGE_QUERY_WITH_EMAIL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message, 'error');
		return;
	} else {
		$query = JFactory::getApplication()->input->post->getArray()['mo_azure_query'];
		$email = JFactory::getApplication()->input->post->getArray()['mo_azure_query_email'];
		$phone = JFactory::getApplication()->input->post->getArray()['mo_azure_query_phone'];
		$contact_us = new MoAzureCustomer();
		$submited = json_decode($contact_us->mo_azure_submit_contact_us($email, $phone, $query),true);
		if(json_last_error() == JSON_ERROR_NONE) {
			if(is_array($submited) && array_key_exists('status', $submited) && $submited['status'] == 'ERROR'){
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $submited['message'],'error');
			}else{
				if ( $submited == false ) {
					$message =  JText::_('COM_MINIORANGE_QUERY_NOT_SUBMITTED');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $message,'error');
				} else {
					$message =  JText::_('COM_MINIORANGE_QUERY_SENT');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $message);
				}
			}
		}
	}
}

//REQUEST FOR A TRIAL/DEMO
function moAzureRequestForDemo()
{
	$post = JFactory::getApplication()->input->post->getArray();

    if ((!isset($post['mo_azure_trial_email'])) || (!isset($post['mo_azure_trial_description']))) {
        $message =  JText::_('COM_MINIORANGE_TRIAL_FILL_EMAIL');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=trial', $message, 'error');
        return;
    }
    
	$mo_azure_trial_email = $post['mo_azure_trial_email'];
    $mo_azure_trial_description = trim($post['mo_azure_trial_description']);
    $mo_azure_demo = $post['mo_azure_demo'];
	
    if (empty($mo_azure_trial_description)) {
		$message =  JText::_('COM_MINIORANGE_TRIAL_ENTER_PLAN');
        $this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=trial', $message, 'error');
        return;
    }

    $customer = new MoAzureCustomer();
    $response = json_decode($customer->mo_azure_request_for_demo($mo_azure_trial_email, $mo_azure_demo, $mo_azure_trial_description));

    if ($response->status != 'ERROR'){
		$message =  JText::_('COM_MINIORANGE_TRIAL_REQUEST_SENT');
        $this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=trial', $message);
	}else {
		$message =  JText::_('COM_MINIORANGE_TRIAL_REQUEST_NOT_SENT');
        $this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=trial', $message, 'error');
        return;
    }
}

//SCHEDULE A CALL
function moAzureCallContactUs(){
		
	$post = JFactory::getApplication()->input->post->getArray();
	$query_email = isset($post['mo_azure_setup_call_email']) ? $post['mo_azure_setup_call_email']: '';
	$query = isset($post['mo_azure_setup_call_issue'])? $post['mo_azure_setup_call_issue']: '';
	$description = isset($post['mo_azure_setup_call_desc'])? $post['mo_azure_setup_call_desc']: '';
	$callDate = isset($post['mo_azure_setup_call_date'])? $post['mo_azure_setup_call_date']: '';
	$timeZone = isset($post['mo_azure_setup_call_timezone'])? $post['mo_azure_setup_call_timezone']: '';
	if (MoAzureUtility::mo_azure_check_empty_or_null($timeZone) || MoAzureUtility::mo_azure_check_empty_or_null($callDate) || MoAzureUtility::mo_azure_check_empty_or_null($query_email) ||  MoAzureUtility::mo_azure_check_empty_or_null($description)) {
		$message =  JText::_('COM_MINIORANGE_CALL_FILL_ALL_DETAILS');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $message, 'error');
		return;
	} else {
		$contact_us = new MoAzureCustomer();
		$submited = json_decode($contact_us->mo_azure_request_for_setupCall($query_email, $query, $description, $callDate, $timeZone), true);
		if (json_last_error() == JSON_ERROR_NONE) {
			if (is_array($submited) && array_key_exists('status', $submited) && $submited['status'] == 'ERROR') {
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $submited['message'], 'error');
			} else {
				if ($submited == false) {
					$message =  JText::_('COM_MINIORANGE_CALL_REQUEST_NOT_SENT');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $message, 'error');
				} else {
					$message =  JText::_('COM_MINIORANGE_CALL_REQUEST_SENT');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_support', $message);
				}
			}
		}

	}
}

function moAzureVerifyCustomer()
	{
		$post =	JFactory::getApplication()->input->post->getArray();
		$message =  JText::_('COM_MINIORANGE_ALL_FIELDS');
		if (MoAzureUtility::mo_azure_check_empty_or_null($post['email']) || MoAzureUtility::mo_azure_check_empty_or_null($post['password'])) {
			JFactory::getApplication()->enqueueMessage(4711, $message);
			return;
		} 
		else 
		{
			$email = $post['email'];
			$password =  $post['password'];
		}
		$customer = new MoAzureCustomer();
		$content = $customer->mo_azure_get_customer_key($email, $password);
		$customerKey = json_decode($content, true);
		if (strcasecmp($customerKey['apiKey'], 'CURL_ERROR') == 0) {
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=mo_azure_account_setup', $customerKey['token'], 'error');
		} 
		else if (json_last_error() == JSON_ERROR_NONE) 
		{
			if (isset($customerKey['id']) && isset($customerKey['apiKey']) && !empty($customerKey['id']) && !empty($customerKey['apiKey'])) {
				$message = JText::_('COM_MINIORANGE_ACCOUNT_RETRIEVED');
				$this->moAzureSaveCustomerConfigurations($email, $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone']);
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message);
			} else {
				$message =JText::_('COM_MINIORANGE_LOGIN_ERROR');
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
			}
		} else {
			$message = JText::_('COM_MINIORANGE_INVALID_CREDENTIALS');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
		}
	}


	function moAzureCancelForm()
	{
		$database_name = '#__miniorange_azure_customer';
		$updatefieldsarray = array(

			'email' 	  			  => '',
			'password'				  => '',
			'customer_key'   	      => '',
			'admin_phone'			  => '',
			'customer_token'   	      => '',
			'api_key'  				  => '',
			'registration_status'     => '',
			'login_status'   	      => 0,
			'transaction_id'		  => '',
			'email_count'   	      => 0,
			'sms_count'   		      => 0,

		);

		$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup');
	}

	function moAzureValidateOtp()
	{

		$otp_token = JFactory::getApplication()->input->post->getArray()["otp_token"];

		if (MoAzureUtility::mo_azure_check_empty_or_null($otp_token)) {
			$message = JText::_('COM_MINIORANGE_VALID_OTP');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
			return;
		} else {
			$otp_token =  JFactory::getApplication()->input->post->getArray()['otp_token'];
		}

		$transaction_id = new MoAzureUtility();
		$transaction_id = $transaction_id->mo_azure_get_details('#__miniorange_azure_customer');
		$transaction_id = $transaction_id['transaction_id'];

		$customer = new MoAzureCustomer();
		$content = json_decode($customer->mo_azure_validate_otp_token($transaction_id, $otp_token), true);

		if (strcasecmp($content['status'], 'SUCCESS') == 0) {

			$customerKey = json_decode($customer->mo_azure_create_customer(), true);
			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(


				'email_count' 	  	 => 0,
				'sms_count' 	  	 => 0,

			);
			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);


			if (strcasecmp($customerKey['status'], 'CUSTOMER_USERNAME_ALREADY_EXISTS') == 0) {	//admin already exists in miniOrange
				
				$content = $customer->mo_azure_get_customer_key();
				$customerKey = json_decode($content, true);
				
				if (json_last_error() == JSON_ERROR_NONE) {
					$this->moAzureSaveCustomerConfigurations($customerKey['email'], $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone']);
					$message = JText::_('COM_MINIORANGE_ACCOUNT_RETRIEVED');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_license_plan', $message);
					return;
				} else {

					$database_name = '#__miniorange_azure_customer';
					$updatefieldsarray = array(


						'login_status' 	  	 => 1,
						'password' 	  	 => '',

					);

					$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
					$message = JText::_('COM_MINIORANGE_ACCOUNT_ALREADY_EXIST');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
					return;
				}
			} else if (strcasecmp($customerKey['status'], 'SUCCESS') == 0) {

				//registration successful
				$this->moAzureSaveCustomerConfigurations($customerKey['email'], $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone']);
				$message = JText::_('COM_MINIORANGE_ACCOUNT_CREATED');
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_license_plan', $message);
				return;
				
			} else if (strcasecmp($customerKey['status'], 'INVALID_EMAIL_QUICK_EMAIL') == 0) {


				$database_name = '#__miniorange_azure_customer';
				$updatefieldsarray = array(

					'registration_status' 	  	 => '',
					'email' 	  				 => '',
					'password' 	  				 => '',
					'transaction_id' 		  	 => '',

				);

				$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
				$message = JText::_('COM_MINIORANGE_ACCOUNT_NOT_CREATED');
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message, 'error');
				return;
			}
		} else if (strcasecmp($customerKey['status'], 'INVALID_EMAIL_QUICK_EMAIL') == 0) {

			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(

				'registration_status' 	  	 => '',
				'email' 	  				 => '',
				'password' 	  				 => '',
				'transaction_id' 		  	 => '',

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
			$message = JText::_('COM_MINIORANGE_ACCOUNT_NOT_CREATED');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message, 'error');
			return;

		} else if (strcasecmp($content['status'], 'CURL_ERROR') == 0) {

			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(

				'registration_status' 	  	 => 'MO_OTP_VALIDATION_FAILURE',

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $content['statusMessage'], 'error');
			return;

		} else {


			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(

				'registration_status' 	  	 => 'MO_OTP_VALIDATION_FAILURE',

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
			$message = JText::_('COM_MINIORANGE_INVALID_OTP');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
			return;
		}
		
		// $message = JText::_('COM_MINIORANGE_AN_ERROR_OCCURRED');
		// $this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
	}

	function moAzureSaveCustomerConfigurations($email, $id, $apiKey, $token, $phone)
	{
		$database_name = '#__miniorange_azure_customer';
		$updatefieldsarray = array(
			'email' 	  			  => $email,
			'customer_key'   	      => $id,
			'api_key'  				  => $apiKey,
			'customer_token'   	      => $token,
			'admin_phone'   	      => $phone,
			'login_status'   	      => 0,
			'registration_status'     => 'SUCCESS',
			'password'   		      => '',
			'email_count'   	      => 0,
			'sms_count'   		      => 0,

		);

		$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
	}

	function moAzureResendOtp()
	{
		$customer = new MoAzureCustomer();
		$auth_type = 'EMAIL';


		$email = new MoAzureUtility();
		$email = $email->mo_azure_get_details('#__miniorange_azure_customer');
		$email = $email['email'];

		$content = json_decode($customer->mo_azure_send_otp_token($auth_type, $email), true);
	
		if (strcasecmp($content['status'], 'SUCCESS') == 0) {

			$customer_details = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_customer');
			$email_count = $customer_details['email_count'];
			$admin_email = $customer_details['email'];

			if ($email_count != '' && $email_count >= 1) {
				$email_count = $email_count + 1;



				$database_name = '#__miniorange_azure_customer';
				$updatefieldsarray = array(

					'email_count' 	  	 => $email_count,
					'transaction_id' 	  	 => $content['txId'],
					'registration_status' 	  	 => 'MO_OTP_DELIVERED_SUCCESS',

				);

				$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);

				$message1 = JText::_('COM_MINIORANGE_OTP_RESEND_MESSAGE1');
				$message2 = JText::_('COM_MINIORANGE_OTP_RESEND_MESSAGE2');
				$message3 = JText::_('COM_MINIORANGE_OTP_RESEND_MESSAGE3');
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message1 . $email_count . $message2 . ($admin_email) . $message3);
			} else {

				$database_name = '#__miniorange_azure_customer';
				$updatefieldsarray = array(

					'email_count' 	  			 => 1,
					'transaction_id' 	  		 => $content['txId'],
					'registration_status' 	  	 => 'MO_OTP_DELIVERED_SUCCESS',

				);

				$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
				$message1 = JText::_('COM_MINIORANGE_OTP_SENT');
				$message2 = JText::_('COM_MINIORANGE_OTP_RESEND_MESSAGE3');
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup',  $message1 . ($admin_email) . $message2);
			}
		} else if (strcasecmp($content['status'], 'CURL_ERROR') == 0) {



			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(

				'registration_status' 	  	 => 'MO_OTP_DELIVERED_FAILURE',

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);

			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup',  $content['statusMessage'], 'error');
		} else {

			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(

				'registration_status' 	  	 => 'MO_OTP_DELIVERED_FAILURE',

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
			$message = JText::_('COM_MINIORANGE_ACCOUNT_NOT_CREATED');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message, 'error');
		}
	}

	function moAzurePhoneVerification()
	{
		$phone = JFactory::getApplication()->input->post->getArray()['phone_number'];
		$phone = str_replace(' ', '', $phone);

		$pattern = "/[\+][0-9]{1,3}[0-9]{10}/";

		if (preg_match($pattern, $phone, $matches, PREG_OFFSET_CAPTURE)) {
			$auth_type = 'SMS';
			$customer = new MoAzureCustomer();
			$send_otp_response = json_decode($customer->mo_azure_send_otp_token($auth_type, $phone));
	
			if ($send_otp_response->status == 'SUCCESS') {

				$sms_count = new MoAzureUtility();
				$sms_count = $sms_count->mo_azure_get_details('#__miniorange_azure_customer');
				$sms_count = $sms_count['sms_count'];

				if ($sms_count != '' && $sms_count >= 1) {
					$sms_count = $sms_count + 1;

					$database_name = '#__miniorange_azure_customer';
					$updatefieldsarray = array(

						'sms_count' 	  			  => $sms_count,
						'transaction_id' 	  		  => $send_otp_response->txId,

					);

					$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
					$message1 = JText::_('COM_MINIORANGE_OTP_RESEND_MESSAGE1');
					$message2 = JText::_('COM_MINIORANGE_OTP_FOR_VERIFICATION');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message1 . $sms_count . $message2 . $phone);
				} else {

					$database_name = '#__miniorange_azure_customer';
					$updatefieldsarray = array(

						'sms_count' 	  			  => 1,
						'transaction_id' 	  		  => $send_otp_response->txId,

					);

					$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
					$message = JText::_('COM_MINIORANGE_ONE_TIME_PASSWORD');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message . $phone);
				}
			} else {
				$message = JText::_('COM_MINIORANGE_ERROR_SENDING_OTP');
				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message);
			}
		} else {
			$message = JText::_('COM_MINIORANGE_ENTER_PHONENO_IN_CORRECT_FORMAT');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup', $message, 'error');
		}
	}

	function moAzureRegisterCustomer()
	{
		$email = '';
		$phone = '';
		$password = '';
		$confirmPassword = '';

		$password = (JFactory::getApplication()->input->post->getArray()["password"]);
		$confirmPassword = (JFactory::getApplication()->input->post->getArray()["confirmPassword"]);

		$email = (JFactory::getApplication()->input->post->getArray()["email"]);

		
		if (MoAzureUtility::mo_azure_check_empty_or_null($email) || MoAzureUtility::mo_azure_check_empty_or_null($password) || MoAzureUtility::mo_azure_check_empty_or_null($confirmPassword)) {
			$message =  JText::_('COM_MINIORANGE_ALL_FIELDS');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetuptab-panel=mo_azure_account_setup',  $message, 'error');
			return;
		} else if (strlen($password) < 6 || strlen($confirmPassword) < 6) {	//check password is of minimum length 6
			$message =  JText::_('COM_MINIORANGE_PASSWORD_MINIMUM_LENGTH');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
			return;
		} else { 
			$email = JFactory::getApplication()->input->post->getArray()["email"];
			$email = strtolower($email);
			$phone = JFactory::getApplication()->input->post->getArray()["phone"];
			$password = JFactory::getApplication()->input->post->getArray()["password"];
			$confirmPassword = JFactory::getApplication()->input->post->getArray()["confirmPassword"];
		}

		if (strcmp($password, $confirmPassword) == 0) {

			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(
				'email' 	  	 		 => $email,
				'admin_phone' 	  	 => $phone,
				'password' 	  	 => $password,

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);

			$customer = new MoAzureCustomer();
			$content = json_decode($customer->mo_azure_check_customer($email), true);

			if (strcasecmp($content['status'], 'CUSTOMER_NOT_FOUND') == 0) {
				$auth_type = 'EMAIL';
				$content = json_decode($customer->mo_azure_send_otp_token($auth_type, $email), true);
		
				if (strcasecmp($content['status'], 'SUCCESS') == 0) {


					$database_name = '#__miniorange_azure_customer';
					$updatefieldsarray = array(
						'email_count' 	  	 		 => 1,
						'transaction_id' 	  	 => $content['txId'],
						'login_status' 	  	 => 0,
						'registration_status' 	  	 => 'MO_OTP_DELIVERED_SUCCESS',

					);

					$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);

					$message1 = JText::_('COM_MINIORANGE_ONE_TIME_PASSWORD');
					$message2 = JText::_('COM_MINIORANGE_ENTER_OTP');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message1 . $email .$message2);
				} else {

					
					$database_name = '#__miniorange_azure_customer';
					$updatefieldsarray = array(


						'login_status' 	  	 => 0,
						'registration_status' 	  	 => 'MO_OTP_DELIVERED_FAILURE',

					);

					$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
					$message = JText::_('COM_MINIORANGE_ERROR_SENDING_EMAIL');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
				}
				//if a curl error
			} else if (strcasecmp($content['status'], 'CURL_ERROR') == 0) {



				$database_name = '#__miniorange_azure_customer';
				$updatefieldsarray = array(


					'login_status' 	  	 => 0,
					'registration_status' 	  	 => 'MO_OTP_DELIVERED_FAILURE',

				);

				$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);

				$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetuptab-panel=mo_azure_account_setup', $content['statusMessage'], 'error');
			} else {

				
				$content = $customer->mo_azure_get_customer_key($email, $password);
				$customerKey = json_decode($content, true);

				if (json_last_error() == JSON_ERROR_NONE) {

					$this->moAzureSaveCustomerConfigurations($email, $customerKey['id'], $customerKey['apiKey'], $customerKey['token'], $customerKey['phone']);
					$message = JText::_('COM_MINIORANGE_ACCOUNT_RETRIEVED');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message);
				} else {



					$database_name = '#__miniorange_azure_customer';
					$updatefieldsarray = array(


						'login_status' 	  	 => 1,
						'registration_status' 	  	 => '',

					);

					$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
					$message = JText::_('COM_MINIORANGE_ACCOUNT_ALREADY_EXIST');
					$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
				}
			}
		} else {
			
			$database_name = '#__miniorange_azure_customer';
			$updatefieldsarray = array(

				'login_status' 	  			 => 0,

			);

			$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
			$message = JText::_('COM_MINIORANGE_CONFIRM_PASSWORD_MISMATCH');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message, 'error');
		}
	}

	function moAzureCustomerLoginForm()
	{
		$database_name = '#__miniorange_azure_customer';
		$updatefieldsarray = array(
			'login_status' 	    => 1,
			'password'   		=> '',
			'email_count'  		=> 0,
			'sms_count'   		=> 0,

		);

		$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup');
	}

	public function moAzureLogout(){
		
		$database_name = '#__miniorange_azure_customer';
		$updatefieldsarray = array(
			'email' 	  			  => '',
			'customer_key'   	      => '',
			'api_key'  				  => '',
			'customer_token'   	      => '',
			'admin_phone'   	      => '',
			'login_status'   	      => 0,
			'registration_status'     => '',
			'password'   		      => '',
			'email_count'   	      => 0,
			'sms_count'   		      => 0,

		);

		$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
		$message = JText::_('COM_MINIORANGE_LOGOUT_MESSAGE');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_account_setup', $message);
	}

	function moAzureSyncAttributeConfig() {
		$post=	JFactory::getApplication()->input->post->getArray();
	
		$mo_azure_name = isset($post['mo_azure_joomla_name'])?$post['mo_azure_joomla_name']:'';
		$mo_azure_username = isset($post['mo_azure_joomla_username'])? $post['mo_azure_joomla_username'] : '';
		$mo_azure_email =isset($post['mo_azure_joomla_email'])? $post['mo_azure_joomla_email'] : "";
	
	
		if( empty($mo_azure_name)|| empty($mo_azure_username) || empty($mo_azure_email) ){	
			$message =  JText::_('COM_MINIORANGE_ENTER_NAME_USERNAME_EMAIL');
			$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync',$message,'error');
			return;
		}		
	
		$database_name = '#__miniorange_azure_sync_config';
		$updatefieldsarray = array(
			'mo_azure_name' 	  	=> trim($mo_azure_name),
			'mo_azure_username' 	=> trim($mo_azure_username),
			'mo_azure_email' 	 	=> trim($mo_azure_email),		
		);
	
		$result = MoAzureUtility::mo_azure_generic_update_query($database_name, $updatefieldsarray);
		
		$message =  JText::_('COM_MINIORANGE_CONNECTION_SUCCESSFULLY_SAVED');
		$this->setRedirect('index.php?option=com_miniorange_azuresync&view=accountsetup&tab-panel=mo_azure_profile_sync',$message );
	}
}