<?php
/** Copyright (C) 2015  miniOrange

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
* @package 		miniOrange User Provisioning/ User Sync with Azure
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

defined('_JEXEC') or die('Restricted access');

class Authorization{
    private static $instance;

    public static function getController(){
        if(!isset(self::$instance)){
            $class = __CLASS__;
            self::$instance = new $class;
        }
        return self::$instance;
    }

    //TO GET ACCESS TOKEN FROM AZURE AD
    public static function mo_azos_get_access_token_using_client_credentials(){
        
        $mo_azure_sync_config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
        $mo_azure_sync_client_secret = $mo_azure_sync_config['mo_azure_sync_client_secret'];
        $mo_azure_sync_client_id = $mo_azure_sync_config['mo_azure_sync_application_id'];
        $mo_azure_sync_scope = "https://graph.microsoft.com/.default";
    
        $mo_azure_sync_tenant_id_endpoints = 'https://login.microsoftonline.com/'.$mo_azure_sync_config['mo_azure_tenant_id'].'/oauth2/v2.0/token';
        $ch = curl_init($mo_azure_sync_tenant_id_endpoints);
        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
        curl_setopt( $ch, CURLOPT_ENCODING, "" );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
        curl_setopt( $ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', 'Authorization: Basic ' . ($mo_azure_sync_client_id . ":" . $mo_azure_sync_client_secret )));
        curl_setopt( $ch, CURLOPT_POSTFIELDS, '&grant_type=client_credentials'.'&client_id='.urlencode($mo_azure_sync_client_id).'&client_secret='.urlencode($mo_azure_sync_client_secret).'&scope='.$mo_azure_sync_scope);
        
        $content = curl_exec($ch);
        curl_close($ch);
        $content = json_decode($content);
        return $content;
    }

    //TO GET USER DETAILS
    public static function mo_get_details($user_info_url, $agrs){
        
        $ch = curl_init($user_info_url);

		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
		curl_setopt( $ch, CURLOPT_ENCODING, "" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
		curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
		curl_setopt( $ch, CURLOPT_POST, false);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: Bearer '.$agrs,));
        $content = curl_exec($ch);

        curl_close($ch);
        return $content;

    }

    //TO CREATE USER IN THE AD
    public static function mo_azure_create_single_user($access_token,$body){

        $endpoint = "https://graph.microsoft.com/beta/users/";
        $body = json_encode($body);
        
        $ch = curl_init($endpoint);
        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
        curl_setopt( $ch, CURLOPT_ENCODING, "" );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
        curl_setopt( $ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','Authorization: Bearer '.$access_token));
        curl_setopt( $ch, CURLOPT_POSTFIELDS, $body);

        $content = curl_exec( $ch );
        $content = json_decode($content);
        curl_close($ch);
        return $content;
    }

    public static function mo_azure_sync_delete_user($access_token, $username){
        
        
        $url = "https://graph.microsoft.com/v1.0/users/".$username;
        $ch = curl_init($url);
        curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
        curl_setopt( $ch, CURLOPT_ENCODING, "" );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
        curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
        curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
        curl_setopt( $ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array(
          'Content-Type: application/json',
          'Authorization: Bearer '.$access_token));
        curl_setopt($ch, CURLOPT_URL, $url);  
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
        $content = curl_exec($ch); 
        $content = json_decode($content);
        curl_close($ch);     
        return $content; 
    }

    public static function mo_azure_get_all_users($endpoints, $agrs){

        $ch = curl_init($endpoints);

		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
		curl_setopt( $ch, CURLOPT_ENCODING, "" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );
		curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
		curl_setopt( $ch, CURLOPT_POST, false);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Authorization: Bearer '.$agrs,));
        $content = curl_exec($ch);

        curl_close($ch);
        return $content;
    }

    public static function mo_azure_create_new_user_in_joomla($mo_azure_user_details){
        $date = date('d-m-y h:i:s');
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $fields = array(
        
            $db->quoteName('email') . ' = ' . $db->quote($mo_azure_user_details['email']),
            $db->quoteName('name') . ' = ' . $db->quote($mo_azure_user_details['name']),
            $db->quoteName('username') . ' = ' . $db->quote($mo_azure_user_details['username']),
            $db->quoteName('registerDate') . ' = ' . $db->quote($date),
            $db->quoteName('params') . ' = ' . $db->quote(""),

        );

        $query->insert($db->quoteName('#__users'))->set($fields);
        $db->setQuery($query);
        $result = $db->execute();
        return $result;

    }

}