<?php
/** Copyright (C) 2015  miniOrange

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
* @package 		miniOrange User Provisioning/ User Sync with Azure
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

defined('_JEXEC') or die('Restricted access');

class Azure{
    
    public static function mo_azos_get_specific_user_detail(){
       
        $access_token= self::mo_azure_sync_get_access_token();
        if($access_token == 'ACCESS_TOKEN_MISSING'){
            return 'ACCESS_TOKEN_MISSING';
        }

        $config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
        $endpoints = 'https://graph.microsoft.com/beta/users/';
        $args = $access_token;
        $username = $config['mo_azure_sync_upn'];

        if (strpos($username,'@')==='false' )
            $username = $username;
        else
            $username = strtok($username,'@');
       
        $username = $username.'@'.$config['mo_azure_tenant_name'];
    
        $user_info_url = $endpoints.urlencode($username);
        $users = self::mo_azure_sync_get_request($user_info_url,$args);
        return $users;
        
    }

    //TO SYNC ALL USERS IN JOOMLA
    public static function mo_azure_sync_all_users_in_joomla($mo_azure_username="userPrincipalName", $mo_azure_name="userPrincipalName", $mo_azure_email="userPrincipalName"){
    
        $access_token= self::mo_azure_sync_get_access_token();
        if($access_token==null){
            return 'ACCESS_TOKEN_MISSING';
        }

        $endpoints = "https://graph.microsoft.com/v1.0/users";
        $args = $access_token;

        $users = Authorization::mo_azure_get_all_users($endpoints,$args);
        
        $ad_users = json_decode($users);

        $ad_user = array($ad_users);

        $mo_azure_no_of_users = count($ad_user[0]->value);

        for($i =0; $i< $mo_azure_no_of_users; $i++){
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $query->select('*');
            $query->from($db->quoteName('#__users'));
            $db->setQuery($query);
            $joomla_users = $db->loadAssocList();

            foreach($joomla_users as $joomla_user){
                if(strtolower($joomla_user['email']) == strtolower($ad_user[0]->value[$i]->$mo_azure_email) || strtolower($joomla_user['username']) == strtolower($ad_user[0]->value[$i]->$mo_azure_username) || strtolower($joomla_user['name']) == strtolower($ad_user[0]->value[$i]->$mo_azure_name) ){
                    $mo_azure_user_presence = 'user_present';
                    $id = $joomla_user['id'];
                    break;
                }
                else{
                    $mo_azure_user_presence = 'user_not_present';
                    $id = $joomla_user['id'];
                 
                }
               
            }
            
            $mo_azure_user_details['id'] = $id;
            $mo_azure_user_details['username'] = $ad_user[0]->value[$i]->$mo_azure_username;
            $mo_azure_user_details['name'] = $ad_user[0]->value[$i]->$mo_azure_name;
            $mo_azure_user_details['email'] = $ad_user[0]->value[$i]->$mo_azure_email;

            if($mo_azure_user_presence=='user_not_present'){
                $mo_azure_create_user_in_joomla = Authorization::mo_azure_create_new_user_in_joomla($mo_azure_user_details);
            }
        }
   
        return 'USERS_CREATED';
    }

    //MAKE AN ARRAY THAT RETURNS THE DATA
    public static function mo_azure_sync_get_request($user_info_url, $agrs){
        
        $user_info = [];
        $user_details = Authorization::mo_get_details($user_info_url, $agrs);
        $user_details = json_decode($user_details);
        foreach($user_details as $key=>$value){
            
            if(empty($value) || !isset($value)){continue;}
            else if(!is_array($value)){
            
                $user_info[$key] = $value;
            }
            else{
                  echo '';
            }
        }
        return $user_info;
    }
    public static function mo_azure_sync_get_access_token(){

        $response = Authorization::mo_azos_get_access_token_using_client_credentials();
        $is_error = isset($response->error) ? $response->error : '';
        if($is_error){
            return 'ACCESS_TOKEN_MISSING';
        }
        else{
            $access_token = $response->access_token;
            return $access_token;
        }
    }
    public static function mo_azure_create_user_in_ad($username){

        $access_token= self::mo_azure_sync_get_access_token();
        if($access_token == 'ACCESS_TOKEN_MISSING'){
            return 'ACCESS_TOKEN_MISSING';
        }
        $config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
        $tenant_name = $config['mo_azure_tenant_name'];

        if (strpos($username, '@')==='false' )
            $username = $username;
        else
            $username = strtok($username,  '@');
            
        $mailNickName = $username;
        $userObject = '{
                "accountEnabled":true,
                "passwordProfile" : {
                "password": "Passw0rd.",
                "forceChangePasswordNextSignIn": false
                },
                "mailNickname": "'.$mailNickName.'",
                "passwordPolicies": "DisablePasswordExpiration"
            }';

        $userObject = json_decode($userObject,true);
        $userObject['userPrincipalName'] = $username.'@'.$tenant_name;
        $userObject['displayName'] = $username;
      
        $response = Authorization::mo_azure_create_single_user($access_token,$userObject);
        return $response; 
        
    }

    public static function mo_azure_sync_delete_user_in_ad($username){

        $access_token= self::mo_azure_sync_get_access_token();
        if($access_token == 'ACCESS_TOKEN_MISSING'){
            return 'ACCESS_TOKEN_MISSING';
        }
        $config = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
        $tenant_name = $config['mo_azure_tenant_name'];
        if (strpos($username, '@')==='false' )
            $username = $username;
        else
            $username = strtok($username,  '@');
    
        $username = $username.'@'.$tenant_name;

        $response = Authorization::mo_azure_sync_delete_user($access_token,$username);  

        return $response;
    }

    public static function mo_azure_sync_individual_user_in_joomla($username,$mo_azure_username='userPrincipalName', $mo_azure_name='userPrincipalName', $mo_azure_email='userPrincipalName'){
        $access_token= self::mo_azure_sync_get_access_token();
        if($access_token == 'ACCESS_TOKEN_MISSING'){
            return 'ACCESS_TOKEN_MISSING';
        }

        $db = JFactory::getDBO();
        $query = $db->getQuery(true)
        ->select('*')
        ->from('#__users')
        ->where($db->quoteName('email') . ' = ' . $db->quote($username) . 'OR' . $db->quoteName('username') . '=' . $db->quote($username));
        $db->setQuery($query);
        $result = $db->loadAssocList();
    
        
        $mo_azure_user_settings = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_sync_config');
		$mo_azure_sync_tenant_name = isset($mo_azure_user_settings['mo_azure_tenant_name'])? $mo_azure_user_settings['mo_azure_tenant_name'] : ""; 
        $endpoints = 'https://graph.microsoft.com/beta/users/';

        if (strpos($username, '@')==='false' )
            $sync_attribute = $username;
        else
            $sync_attribute = strtok($username,  '@');
        
        $sync_attribute = $sync_attribute.'@'.$mo_azure_sync_tenant_name;

        $user_info_url = $endpoints.urlencode($sync_attribute);
            
        $user_Details = Authorization::mo_get_details($user_info_url, $access_token);
        $user_Details = json_decode($user_Details);
        $user_Details = array($user_Details);
       
        $user_not_present = isset($user_Details[0]->error) ? 'user_not_present' : 'user_present';

        if($user_not_present =='user_not_present'){
           return 'USER_NOT_PRESENT';
        }

        $user_in_joomla = isset($result) ? $result : '';
        $mo_attributes_to_sync['name'] = isset($user_Details[0]->$mo_azure_name) ? $user_Details[0]->$mo_azure_name : $user_Details[0]->$mo_azure_username ;
        $mo_attributes_to_sync['username'] = $user_Details[0]->$mo_azure_username;
        $mo_attributes_to_sync['email'] = $user_Details[0]->$mo_azure_email;
        
        if(!$user_in_joomla){
            $status = Authorization::mo_azure_create_new_user_in_joomla($mo_attributes_to_sync);
            return;
        }
    }
}