<?php
/** Copyright (C) 2015  miniOrange

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
* @package 		miniOrange User Provisioning/ User Sync with Azure
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/
/**
This library is miniOrange Authentication Service. 
Contains Request Calls to Customer service.

**/
//
defined( '_JEXEC' ) or die( 'Restricted access' );

class MoAzureCustomer{
	
	public $email;
	public $phone;
	public $customerKey;
	public $transactionId;

	/*
	** Initial values are hardcoded to support the miniOrange framework to generate OTP for email.
	** We need the default value for creating the OTP the first time,
	** As we don't have the Default keys available before registering the user to our server.
	** This default values are only required for sending an One Time Passcode at the user provided email address.
	*/
	
	
	private $defaultCustomerKey = "16555";
	private $defaultApiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

	
	function mo_azure_submit_contact_us( $q_email, $q_phone, $query) {
			
		$url = 'https://login.xecurify.com/moas/api/notify/send';
		$ch = curl_init($url);
		$customerKey = "16555";
		$apiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
		
		$currentTimeInMillis = round(microtime(true) * 1000);
		$stringToHash = $customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
		$hashValue = hash("sha512", $stringToHash);
		$customerKeyHeader = "Customer-Key: " . $customerKey;
		$timestampHeader = "Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
		$authorizationHeader = "Authorization: " . $hashValue;
		$fromEmail = $q_email;
		$phpVersion = phpversion();
		$jVersion = new JVersion;
		$jCmsVersion = $jVersion->getShortVersion();
		$moPluginVersion = MoAzureUtility::mo_azure_get_plugin_version();
		$moSystemOS = MoAzureUtility::mo_azure_get_operating_system();
		$subject = "Query for MiniOrange Joomla Azure Sync Free | " . $phpVersion ." | ". $jCmsVersion." | ".$moPluginVersion.' | ' . $moSystemOS.' - '.$fromEmail;
		
		$currentUserEmail 	= JFactory::getUser();
		$adminEmail         = $currentUserEmail->email;
		$pluginInfo = '['.$moPluginVersion.' | PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';
		$query = '[MiniOrange Joomla Azure Sync Free | '.$phpVersion. ' | '.$jCmsVersion.' | '.$moPluginVersion.' | ' . $moSystemOS.'] ' . $query;
		$content = '<div >Hello, <br><br>
					<strong>Company</strong> :<a href="'.$_SERVER['SERVER_NAME'].'" target="_blank" >'.$_SERVER['SERVER_NAME'].'</a><br><br>
					<strong>Phone Number</strong> :'.$q_phone.'<br><br>
					<strong>Admin Email : </strong><a href="mailto:'.$adminEmail.'" target="_blank">'.$adminEmail.'</a><br><br>
					<b>Email :<a href="mailto:'.$fromEmail.'" target="_blank">'.$fromEmail.'</a></b><br><br>
					<b>Query</b>: '.$query. '</b></div>';

		$fields = array(
			'customerKey' => $customerKey,
			'sendEmail' => true,
			'email' => array(
				'customerKey' => $customerKey,
				'fromEmail' => $fromEmail,
				'fromName' => 'miniOrange',
				'toEmail' => 'joomlasupport@xecurify.com',
				'toName' => 'joomlasupport@xecurify.com',
				'subject' => $subject,
				'content' => $content
			),
		);
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}

	function mo_azure_request_for_demo($email, $demo,$description = '')
	{
		$url = 'https://login.xecurify.com/moas/api/notify/send';
		$ch = curl_init($url);
		$customerKey = "16555";
		$apiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
		$currentTimeInMillis = round(microtime(true) * 1000);
		$stringToHash = $customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
		$hashValue = hash("sha512", $stringToHash);
		$customerKeyHeader = "Customer-Key: " . $customerKey;
		$timestampHeader = "Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
		$authorizationHeader = "Authorization: " . $hashValue;
		$fromEmail = $email;
		$subject = 'MiniOrange Joomla Azure Sync Request for '.$demo;

		$phpVersion = phpversion();
		$jVersion = new JVersion;
		$jCmsVersion = $jVersion->getShortVersion();
		$moPluginVersion = MoAzureUtility::mo_azure_get_plugin_version();
		$moSystemOS = MoAzureUtility::mo_azure_get_operating_system();

		$currentUserEmail 	= JFactory::getUser();
		$adminEmail         = $currentUserEmail->email;
		$pluginInfo = '['.$moPluginVersion.' | Joomla Version '.$jCmsVersion.' | PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';

		$content = '<div >Hello, <br>
					<br><strong>Company :</strong><a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>
					<strong>Admin Email :</strong><a href="mailto:'.$adminEmail.'"target="_blank">'.$adminEmail.'</a><br><br>
					<strong>Email :</strong><a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>
					<strong>Plugin Info: </strong>'.$pluginInfo.'<br><br>
					<strong>Request for : </strong>'.$demo. '<br><br>
					<strong>Description: </strong>' . $description . '</div>';

		$fields = array(
			'customerKey' => $customerKey,
			'sendEmail' => true,
			'email' => array(
				'customerKey' => $customerKey,
				'fromEmail' => $fromEmail,
				'fromName' => 'miniOrange',
				'toEmail' => 'joomlasupport@xecurify.com',
				'toName' => 'joomlasupport@xecurify.com',
				'subject' => $subject,
				'content' => $content
			),
		);
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}


	function mo_azure_request_for_setupCall($email, $query, $description, $callDate, $timeZone)
	{
		$url = 'https://login.xecurify.com/moas/api/notify/send';
		$customerKey = "16555";
		$apiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";

		$currentTimeInMillis = round(microtime(true) * 1000);
		$stringToHash = $customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
		$hashValue = hash("sha512", $stringToHash);
		$customerKeyHeader = "Customer-Key: " . $customerKey;
		$timestampHeader = "Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
		$authorizationHeader = "Authorization: " . $hashValue;
		$fromEmail = $email;

		$subject = "MiniOrange Joomla Azure Sync Free - Screen Share/Call Request";
		$phpVersion = phpversion();
			
			$jVersion = new JVersion;
		$jCmsVersion = $jVersion->getShortVersion();
		$moPluginVersion = MoAzureUtility::mo_azure_get_plugin_version();
		$moSystemOS = MoAzureUtility::mo_azure_get_operating_system();

		$currentUserEmail 	= JFactory::getUser();
		$adminEmail         = $currentUserEmail->email;

		$pluginInfo = '[ Joomla Azure User Sync '.$moPluginVersion.' | PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';
		$content = '<div>Hello, <br><br>
					<strong>Company :</strong><a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>
					<strong>Plugin Info: </strong>'.$pluginInfo.'<br><br>
					<strong>Admin Email :</strong><a href="mailto:'.$adminEmail.'"target="_blank">'.$adminEmail.'</a><br><br>
					<strong>Email :</strong><a href="mailto:' . $fromEmail . '" target="_blank">' . $fromEmail . '</a><br><br>
					<strong>Time Zone:</strong> ' . $timeZone . '<br><br><strong>Date to set up call: </strong>' . $callDate . '<br><br>
					<strong>Issue : </strong>' . $query . '<br><br>
					<strong>Description:</strong> ' . $description . '</div>';

		$fields = array(
			'customerKey' => $customerKey,
			'sendEmail' => true,
			'email' => array(
				'customerKey' => $customerKey,
				'fromEmail' => $fromEmail,
				'fromName' => 'miniOrange',
				'toEmail' => 'joomlasupport@xecurify.com',
				'toName' => 'joomlasupport@xecurify.com',
				'subject' => $subject,
				'content' => $content
			),
		);
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}


	function mo_azure_get_customer_key($email,$password) {
		if(!MoAzureUtility::mo_azure_is_curl_installed()) {
			return json_encode(array("apiKey"=>'CURL_ERROR','token'=>'<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.'));
		}
		
		$hostname = MoAzureUtility::mo_azure_get_hostname();
		$url = $hostname. "/moas/rest/customer/key";
		$fields = array(
			'email' => $email,
			'password' => $password
		);
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', 'charset: UTF-8', 'Authorization: Basic' );
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}

	function mo_azure_validate_otp_token($transactionId,$otpToken){
		if(!MoAzureUtility::mo_azure_is_curl_installed()) {
			return json_encode(array("status"=>'CURL_ERROR','statusMessage'=>'<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.'));
		}
		$hostname = MoAzureUtility::mo_azure_get_hostname();
		$url = $hostname . '/moas/api/auth/validate';
		$customerKey =  $this->defaultCustomerKey;
		$apiKey =  $this->defaultApiKey;

		/* Current time in milliseconds since midnight, January 1, 1970 UTC. */
		$currentTimeInMillis = round(microtime(true) * 1000);

		/* Creating the Hash using SHA-512 algorithm */
		$stringToHash = $customerKey .  number_format($currentTimeInMillis, 0, '', '') . $apiKey;
		$hashValue = hash("sha512", $stringToHash);

		$customerKeyHeader = "Customer-Key: " . $customerKey;
		$timestampHeader = "Timestamp: " .  number_format($currentTimeInMillis, 0, '', '');
		$authorizationHeader = "Authorization: " . $hashValue;

		$fields = '';

			//*check for otp over sms/email
			$fields = array(
				'txId' => $transactionId,
				'token' => $otpToken,
			);

		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);

	}
	
	function mo_azure_create_customer(){
		if(!MoAzureUtility::mo_azure_is_curl_installed()) {
			return json_encode(array("statusCode"=>'ERROR','statusMessage'=>$error . '. Please check your configuration. Also check troubleshooting under otp configuration.'));
		}
		$hostname = MoAzureUtility::mo_azure_get_hostname();
		$url = $hostname . '/moas/rest/customer/add';
		$current_user =  JFactory::getUser();
		$customer_details = MoAzureUtility::mo_azure_get_details('#__miniorange_azure_customer');
		
		$this->email = $customer_details['email'];
		$this->phone = $customer_details['admin_phone'];
		$password = $customer_details['password'];
		
		$fields = array(
			'companyName' => $_SERVER['SERVER_NAME'],
			'areaOfInterest' => 'JOOMLA Azure Sync Free',
			'firstname' => $current_user->name,
			'lastname' => '',
			'email' => $this->email,
			'phone' => $this->phone,
			'password' => $password
		);
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', 'charset: UTF-8', 'Authorization: Basic' );
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}

	function mo_azure_send_otp_token($auth_type, $emailOrPhone){
		
		if(!MoAzureUtility::mo_azure_is_curl_installed()) {
			return json_encode(array("status"=>'CURL_ERROR','statusMessage'=>'<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.'));
		}
		
		$hostname = MoAzureUtility::mo_azure_get_hostname();
		$url = $hostname . '/moas/api/auth/challenge';
		$customerKey =  $this->defaultCustomerKey;
		$apiKey =  $this->defaultApiKey;
		
		/* Current time in milliseconds since midnight, January 1, 1970 UTC. */
		$currentTimeInMillis = round(microtime(true) * 1000);

		/* Creating the Hash using SHA-512 algorithm */
		$stringToHash = $customerKey .  number_format($currentTimeInMillis, 0, '', '') . $apiKey;
		$hashValue = hash("sha512", $stringToHash);

		$customerKeyHeader = "Customer-Key: " . $customerKey;
		$timestampHeader = "Timestamp: " .  number_format($currentTimeInMillis, 0, '', '');
		$authorizationHeader = "Authorization: " . $hashValue;
		if($auth_type=="EMAIL")
		{
			$fields = array(
				'customerKey' => $this->defaultCustomerKey,
				'email' => $emailOrPhone,
				'authType' => $auth_type,
				'transactionName' => 'JOOMLA LDAP Free'
			);
		}
		else{
			$fields = array(
				'customerKey' => $this->defaultCustomerKey,
				'phone' => $emailOrPhone,
				'authType' => $auth_type,
				'transactionName' => 'JOOMLA LDAP Free'
			);
		}
		
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}

	function mo_azure_check_customer($email) {
		if(!MoAzureUtility::mo_azure_is_curl_installed()) {
			return json_encode(array("status"=>'CURL_ERROR','statusMessage'=>'<a href="http://php.net/manual/en/curl.installation.php">PHP cURL extension</a> is not installed or disabled.'));
		}
		$hostname = MoAzureUtility::mo_azure_get_hostname();
		$url = $hostname . "/moas/rest/customer/check-if-exists";
		$ch 	= curl_init( $url );
		
		$fields = array(
			'email' 	=> $email,
		);
		$field_string = json_encode( $fields );
		$http_header_array = array( 'Content-Type: application/json', 'charset: UTF-8', 'Authorization: Basic' );
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}

	//POST CALL FUNCTIONS
	public static function mo_post_curl($url, $fields, $http_header_array){
		$ch = curl_init($url);
		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, true );
		curl_setopt( $ch, CURLOPT_ENCODING, "" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
		curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, false );   
		
		curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, $http_header_array );
		curl_setopt( $ch, CURLOPT_POST, true);
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $fields);
			
		$content = curl_exec( $ch );
		if(curl_errno($ch)){
			echo 'Request Error:' . curl_error($ch);
		return false;
		}
		curl_close($ch);

		return $content;
	}


	public static function mo_azure_efficiency_check($test_configuration)
	{
		
		$url = 'https://login.xecurify.com/moas/api/notify/send';
		$ch = curl_init($url);
		$customerKey = "16555";
		$apiKey = "fFd2XcvTGDemZvbw1bcUesNJWEqKbbUq";
		$currentTimeInMillis = round(microtime(true) * 1000);
		$stringToHash = $customerKey . number_format($currentTimeInMillis, 0, '', '') . $apiKey;
		$hashValue = hash("sha512", $stringToHash);
		$customerKeyHeader = "Customer-Key: " . $customerKey;
		$timestampHeader = "Timestamp: " . number_format($currentTimeInMillis, 0, '', '');
		$authorizationHeader = "Authorization: " . $hashValue;
	
		$subject = 'MiniOrange User Provisioning for Joomla with Azure Efficiency Check ';

		$phpVersion = phpversion();
		$jVersion = new JVersion;
		$jCmsVersion = $jVersion->getShortVersion();
		$moPluginVersion = MoAzureUtility::mo_azure_get_plugin_version();
		$moSystemOS = MoAzureUtility::mo_azure_get_operating_system();
		

		$currentUserEmail 	= JFactory::getUser();
		$adminEmail         = $currentUserEmail->email;
		$pluginInfo = '['.$moPluginVersion.' Joomla Version '.$jCmsVersion.'| PHP ' . $phpVersion.' | System OS '.$moSystemOS.' ] ';

		$content = '<div >Hello, <br>
					<br><strong>Company :</strong><a href="' . $_SERVER['SERVER_NAME'] . '" target="_blank" >' . $_SERVER['SERVER_NAME'] . '</a><br><br>
					<strong>Admin Email :</strong><a href="mailto:'.$adminEmail.'"target="_blank">'.$adminEmail.'</a><br><br>
					<strong>Plugin Info: </strong>'.$pluginInfo.'<br><br>
					<strong>Test Configuration : </strong> '.$test_configuration.'
					</div>';

		$fields = array(
			'customerKey' => $customerKey,
			'sendEmail' => true,
			'email' => array(
				'customerKey' => $customerKey,
				'fromEmail' => $adminEmail,
				'fromName' => 'miniOrange',
				'toEmail' => 'riya.obheroi@xecurify.com',
				'toName' => 'riya.obheroi@xecurify.com',
				'subject' => $subject,
				'content' => $content
			),
		);
		$field_string = json_encode($fields);
		$http_header_array = array( 'Content-Type: application/json', $customerKeyHeader, $timestampHeader, $authorizationHeader);
		return self::mo_post_curl($url,$field_string,$http_header_array);
	}


}?>